/* Utils.c generated by valac 0.36.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))



gboolean power_utils_type_is_battery (guint32 device_type);
#define DEVICE_TYPE_UNKNOWN ((guint32) 0)
#define DEVICE_TYPE_LINE_POWER ((guint32) 1)
gboolean power_utils_type_has_device_icon (guint32 device_type);
#define DEVICE_TYPE_PHONE ((guint32) 8)
#define DEVICE_TYPE_MOUSE ((guint32) 5)
#define DEVICE_TYPE_KEYBOARD ((guint32) 6)
GType power_services_device_get_type (void) G_GNUC_CONST;
gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_symbolic_icon_name_for_backlight (void);
gdouble power_services_device_get_percentage (PowerServicesDevice* self);
gboolean power_utils_is_charging (guint32 state);
guint32 power_services_device_get_state (PowerServicesDevice* self);
gchar* power_utils_get_battery_icon (gdouble percentage, gint64 remaining_time);
gint64 power_services_device_get_time_to_empty (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
#define DEVICE_STATE_FULLY_CHARGED ((guint32) 4)
#define DEVICE_STATE_CHARGING ((guint32) 1)
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
#define DEVICE_TYPE_UPS ((guint32) 3)
#define DEVICE_TYPE_MONITOR ((guint32) 4)
#define DEVICE_TYPE_PDA ((guint32) 7)
const gchar* power_services_device_get_vendor (PowerServicesDevice* self);
const gchar* power_services_device_get_model (PowerServicesDevice* self);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
gint64 power_services_device_get_time_to_full (PowerServicesDevice* self);
#define CONSTANTS_GETTEXT_PACKAGE "power-indicator"
void power_utils_translations (void);


gboolean power_utils_type_is_battery (guint32 device_type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint32 _tmp1_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = device_type;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp1_ != DEVICE_TYPE_UNKNOWN) {
#line 87 "Utils.c"
		guint32 _tmp2_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp2_ = device_type;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = _tmp2_ != DEVICE_TYPE_LINE_POWER;
#line 93 "Utils.c"
	} else {
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = FALSE;
#line 97 "Utils.c"
	}
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 103 "Utils.c"
}


gboolean power_utils_type_has_device_icon (guint32 device_type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint32 _tmp2_;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = device_type;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp2_ == DEVICE_TYPE_PHONE) {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = TRUE;
#line 118 "Utils.c"
	} else {
		guint32 _tmp3_;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp3_ = device_type;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = _tmp3_ == DEVICE_TYPE_MOUSE;
#line 125 "Utils.c"
	}
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp1_) {
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = TRUE;
#line 131 "Utils.c"
	} else {
		guint32 _tmp4_;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp4_ = device_type;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = _tmp4_ == DEVICE_TYPE_KEYBOARD;
#line 138 "Utils.c"
	}
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 144 "Utils.c"
}


gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	PowerServicesDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 29 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = battery;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = power_utils_get_icon_name_for_battery (_tmp0_);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = g_strconcat (_tmp2_, "-symbolic", NULL);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp4_ = _tmp3_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_g_free0 (_tmp2_);
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp4_;
#line 30 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 173 "Utils.c"
}


gchar* power_utils_get_symbolic_icon_name_for_backlight (void) {
	gchar* result = NULL;
	gchar* _tmp0_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = g_strdup ("display-brightness-symbolic");
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 186 "Utils.c"
}


gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	PowerServicesDevice* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 37 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = battery;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = power_services_device_get_percentage (_tmp1_);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp3_ == ((gdouble) 100)) {
#line 206 "Utils.c"
		PowerServicesDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		gboolean _tmp7_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp4_ = battery;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp5_ = power_services_device_get_state (_tmp4_);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp6_ = _tmp5_;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp7_ = power_utils_is_charging (_tmp6_);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = _tmp7_ == TRUE;
#line 221 "Utils.c"
	} else {
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = FALSE;
#line 225 "Utils.c"
	}
#line 38 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp0_) {
#line 229 "Utils.c"
		gchar* _tmp8_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp8_ = g_strdup ("battery-full-charged");
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp8_;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 237 "Utils.c"
	} else {
		const gchar* _tmp9_ = NULL;
		PowerServicesDevice* _tmp10_;
		guint32 _tmp11_;
		guint32 _tmp12_;
		gboolean _tmp13_;
		PowerServicesDevice* _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		PowerServicesDevice* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp10_ = battery;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp11_ = power_services_device_get_state (_tmp10_);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp12_ = _tmp11_;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp13_ = power_utils_is_charging (_tmp12_);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp13_) {
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp9_ = "-charging";
#line 266 "Utils.c"
		} else {
#line 42 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp9_ = "";
#line 270 "Utils.c"
		}
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp14_ = battery;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = power_services_device_get_percentage (_tmp14_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp16_ = _tmp15_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp17_ = battery;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp18_ = power_services_device_get_time_to_empty (_tmp17_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp19_ = _tmp18_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp20_ = power_utils_get_battery_icon (_tmp16_, _tmp19_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp21_ = _tmp20_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp22_ = g_strconcat (_tmp21_, _tmp9_, NULL);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp23_ = _tmp22_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp21_);
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp23_;
#line 41 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 298 "Utils.c"
	}
}


gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device) {
	gchar* result = NULL;
	PowerServicesDevice* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = device;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = power_services_device_get_device_type (_tmp0_);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	switch (_tmp2_) {
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 320 "Utils.c"
		{
			gchar* _tmp3_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp3_ = g_strdup ("phone");
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp3_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 329 "Utils.c"
		}
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 333 "Utils.c"
		{
			gchar* _tmp4_;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = g_strdup ("input-mouse");
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp4_;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 342 "Utils.c"
		}
#line 47 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 346 "Utils.c"
		{
			gchar* _tmp5_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp5_ = g_strdup ("input-keyboard");
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp5_;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 355 "Utils.c"
		}
		default:
		{
			PowerServicesDevice* _tmp6_;
			gchar* _tmp7_;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = device;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp7_ = power_utils_get_icon_name_for_battery (_tmp6_);
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			result = _tmp7_;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			return result;
#line 369 "Utils.c"
		}
	}
}


gchar* power_utils_get_battery_icon (gdouble percentage, gint64 remaining_time) {
	gchar* result = NULL;
	gdouble _tmp0_;
	gboolean _tmp2_ = FALSE;
	gdouble _tmp3_;
	gdouble _tmp8_;
	gdouble _tmp10_;
	gdouble _tmp12_;
	gchar* _tmp14_;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = percentage;
#line 56 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp0_ <= ((gdouble) 0)) {
#line 388 "Utils.c"
		gchar* _tmp1_;
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp1_ = g_strdup ("battery-good");
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp1_;
#line 57 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 396 "Utils.c"
	}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = percentage;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp3_ < ((gdouble) 10)) {
#line 402 "Utils.c"
		gboolean _tmp4_ = FALSE;
		gint64 _tmp5_;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp5_ = remaining_time;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp5_ == ((gint64) 0)) {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = TRUE;
#line 411 "Utils.c"
		} else {
			gint64 _tmp6_;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = remaining_time;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = _tmp6_ < ((gint64) (30 * 60));
#line 418 "Utils.c"
		}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp2_ = _tmp4_;
#line 422 "Utils.c"
	} else {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp2_ = FALSE;
#line 426 "Utils.c"
	}
#line 60 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp2_) {
#line 430 "Utils.c"
		gchar* _tmp7_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp7_ = g_strdup ("battery-empty");
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp7_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 438 "Utils.c"
	}
#line 64 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp8_ = percentage;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp8_ < ((gdouble) 30)) {
#line 444 "Utils.c"
		gchar* _tmp9_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp9_ = g_strdup ("battery-caution");
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp9_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 452 "Utils.c"
	}
#line 68 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp10_ = percentage;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp10_ < ((gdouble) 60)) {
#line 458 "Utils.c"
		gchar* _tmp11_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp11_ = g_strdup ("battery-low");
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp11_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 466 "Utils.c"
	}
#line 72 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp12_ = percentage;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp12_ < ((gdouble) 80)) {
#line 472 "Utils.c"
		gchar* _tmp13_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp13_ = g_strdup ("battery-good");
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp13_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 480 "Utils.c"
	}
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp14_ = g_strdup ("battery-full");
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp14_;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 488 "Utils.c"
}


gboolean power_utils_is_charging (guint32 state) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint32 _tmp1_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = state;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp1_ == DEVICE_STATE_FULLY_CHARGED) {
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = TRUE;
#line 502 "Utils.c"
	} else {
		guint32 _tmp2_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp2_ = state;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp0_ = _tmp2_ == DEVICE_STATE_CHARGING;
#line 509 "Utils.c"
	}
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp0_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 515 "Utils.c"
}


gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	PowerServicesDevice* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	gboolean _tmp17_ = FALSE;
	PowerServicesDevice* _tmp18_;
	guint32 _tmp19_;
	guint32 _tmp20_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = g_strdup ("");
#line 84 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	title = _tmp0_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = battery;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = power_services_device_get_device_type (_tmp1_);
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	switch (_tmp3_) {
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_BATTERY:
#line 548 "Utils.c"
		{
			gchar* _tmp4_;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp4_ = g_strdup (_ ("Battery"));
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp4_;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 559 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_UPS:
#line 563 "Utils.c"
		{
			gchar* _tmp5_;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp5_ = g_strdup (_ ("UPS"));
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp5_;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 574 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MONITOR:
#line 578 "Utils.c"
		{
			gchar* _tmp6_;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp6_ = g_strdup (_ ("Display"));
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp6_;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 589 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 593 "Utils.c"
		{
			gchar* _tmp7_;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp7_ = g_strdup (_ ("Mouse"));
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp7_;
#line 91 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 604 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 608 "Utils.c"
		{
			gchar* _tmp8_;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp8_ = g_strdup (_ ("Keyboard"));
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp8_;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 619 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PDA:
#line 623 "Utils.c"
		{
			gchar* _tmp9_;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp9_ = g_strdup (_ ("PDA"));
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp9_;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 634 "Utils.c"
		}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 638 "Utils.c"
		{
			gchar* _tmp10_;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp10_ = g_strdup (_ ("Phone"));
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp10_;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 649 "Utils.c"
		}
		default:
		{
			PowerServicesDevice* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp11_ = battery;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp12_ = power_services_device_get_vendor (_tmp11_);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp13_ = _tmp12_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp14_ = g_strconcat (_tmp13_, " ", NULL);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp15_ = _tmp14_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp16_ = g_strconcat (_tmp15_, _ ("Device"), NULL);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (title);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			title = _tmp16_;
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (_tmp15_);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			break;
#line 679 "Utils.c"
		}
	}
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp18_ = battery;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp19_ = power_services_device_get_device_type (_tmp18_);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp20_ = _tmp19_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp20_ == DEVICE_TYPE_PHONE) {
#line 690 "Utils.c"
		PowerServicesDevice* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp21_ = battery;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp22_ = power_services_device_get_model (_tmp21_);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp23_ = _tmp22_;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp17_ = g_strcmp0 (_tmp23_, "") != 0;
#line 702 "Utils.c"
	} else {
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp17_ = FALSE;
#line 706 "Utils.c"
	}
#line 98 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp17_) {
#line 710 "Utils.c"
		PowerServicesDevice* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp24_ = battery;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp25_ = power_services_device_get_model (_tmp24_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp26_ = _tmp25_;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp27_ = g_strdup (_tmp26_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (title);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		title = _tmp27_;
#line 727 "Utils.c"
	}
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp28_ = title;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp29_ = g_strdup_printf ("<b>%s</b>", _tmp28_);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = _tmp29_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_g_free0 (title);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 739 "Utils.c"
}


gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery) {
	gchar* result = NULL;
	gint percent = 0;
	PowerServicesDevice* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gboolean charging = FALSE;
	PowerServicesDevice* _tmp4_;
	guint32 _tmp5_;
	guint32 _tmp6_;
	gboolean _tmp7_;
	gint _tmp8_;
	gchar* info = NULL;
	gchar* _tmp10_;
	gboolean _tmp11_;
#line 105 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp0_ = battery;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp1_ = power_services_device_get_percentage (_tmp0_);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp3_ = round (_tmp2_);
#line 106 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	percent = (gint) _tmp3_;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp4_ = battery;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp5_ = power_services_device_get_state (_tmp4_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp6_ = _tmp5_;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp7_ = power_utils_is_charging (_tmp6_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	charging = _tmp7_;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp8_ = percent;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp8_ <= 0) {
#line 785 "Utils.c"
		gchar* _tmp9_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp9_ = g_strdup (_ ("Calculating…"));
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		result = _tmp9_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		return result;
#line 793 "Utils.c"
	}
#line 113 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp10_ = g_strdup ("");
#line 113 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	info = _tmp10_;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	_tmp11_ = charging;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	if (_tmp11_) {
#line 803 "Utils.c"
		const gchar* _tmp12_;
		gint _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gint64 seconds = 0LL;
		PowerServicesDevice* _tmp17_;
		gint64 _tmp18_;
		gint64 _tmp19_;
		gint64 _tmp20_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp12_ = info;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp13_ = percent;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp14_ = g_strdup_printf (_ ("%i%% charged"), _tmp13_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp15_ = _tmp14_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (info);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		info = _tmp16_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp15_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp17_ = battery;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp18_ = power_services_device_get_time_to_full (_tmp17_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp19_ = _tmp18_;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		seconds = _tmp19_;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp20_ = seconds;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp20_ > ((gint64) 0)) {
#line 842 "Utils.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gint64 _tmp23_;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp21_ = info;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp22_ = g_strconcat (_tmp21_, " - ", NULL);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (info);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			info = _tmp22_;
#line 122 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp23_ = seconds;
#line 122 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			if (_tmp23_ >= ((gint64) 86400)) {
#line 858 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp24_;
				const gchar* _tmp25_;
				gint64 _tmp26_;
				gint64 _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp24_ = seconds;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				days = _tmp24_ / 86400;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp25_ = info;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp26_ = days;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp27_ = days;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp28_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until full", "%lld days until full", (gulong) _tmp26_), _tmp27_);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp29_ = _tmp28_;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (info);
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				info = _tmp30_;
#line 124 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (_tmp29_);
#line 889 "Utils.c"
			} else {
				gint64 _tmp31_;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp31_ = seconds;
#line 125 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				if (_tmp31_ >= ((gint64) 3600)) {
#line 896 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp32_;
					const gchar* _tmp33_;
					gint64 _tmp34_;
					gint64 _tmp35_;
					gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp32_ = seconds;
#line 126 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					hours = _tmp32_ / 3600;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp33_ = info;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp34_ = hours;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp35_ = hours;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp36_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) _tmp34_), _tmp35_);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp37_ = _tmp36_;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp38_ = g_strconcat (_tmp33_, _tmp37_, NULL);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (info);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					info = _tmp38_;
#line 127 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (_tmp37_);
#line 927 "Utils.c"
				} else {
					gint64 _tmp39_;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp39_ = seconds;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					if (_tmp39_ >= ((gint64) 60)) {
#line 934 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp40_;
						const gchar* _tmp41_;
						gint64 _tmp42_;
						gint64 _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp40_ = seconds;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						minutes = _tmp40_ / 60;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp41_ = info;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp42_ = minutes;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp43_ = minutes;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp44_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) _tmp42_), _tmp43_);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp45_ = _tmp44_;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp46_ = g_strconcat (_tmp41_, _tmp45_, NULL);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp46_;
#line 130 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp45_);
#line 965 "Utils.c"
					} else {
						const gchar* _tmp47_;
						gint64 _tmp48_;
						gint64 _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						gchar* _tmp52_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp47_ = info;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp48_ = seconds;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp49_ = seconds;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp50_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp48_), _tmp49_);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp51_ = _tmp50_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp52_;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp51_);
#line 991 "Utils.c"
					}
				}
			}
		}
	} else {
		const gchar* _tmp53_;
		gint _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		gint64 seconds = 0LL;
		PowerServicesDevice* _tmp58_;
		gint64 _tmp59_;
		gint64 _tmp60_;
		gint64 _tmp61_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp53_ = info;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp54_ = percent;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp55_ = g_strdup_printf (_ ("%i%% remaining"), _tmp54_);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp56_ = _tmp55_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (info);
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		info = _tmp57_;
#line 136 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_g_free0 (_tmp56_);
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp58_ = battery;
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp59_ = power_services_device_get_time_to_empty (_tmp58_);
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp60_ = _tmp59_;
#line 138 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		seconds = _tmp60_;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		_tmp61_ = seconds;
#line 140 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
		if (_tmp61_ > ((gint64) 0)) {
#line 1035 "Utils.c"
			const gchar* _tmp62_;
			gchar* _tmp63_;
			gint64 _tmp64_;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp62_ = info;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp63_ = g_strconcat (_tmp62_, " - ", NULL);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_g_free0 (info);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			info = _tmp63_;
#line 142 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			_tmp64_ = seconds;
#line 142 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
			if (_tmp64_ >= ((gint64) 86400)) {
#line 1051 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp65_;
				const gchar* _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp65_ = seconds;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				days = _tmp65_ / 86400;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp66_ = info;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp67_ = days;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp68_ = days;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp69_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until empty", "%lld days until empty", (gulong) _tmp67_), _tmp68_);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp70_ = _tmp69_;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp71_ = g_strconcat (_tmp66_, _tmp70_, NULL);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (info);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				info = _tmp71_;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_g_free0 (_tmp70_);
#line 1082 "Utils.c"
			} else {
				gint64 _tmp72_;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				_tmp72_ = seconds;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
				if (_tmp72_ >= ((gint64) 3600)) {
#line 1089 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp73_;
					const gchar* _tmp74_;
					gint64 _tmp75_;
					gint64 _tmp76_;
					gchar* _tmp77_;
					gchar* _tmp78_;
					gchar* _tmp79_;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp73_ = seconds;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					hours = _tmp73_ / 3600;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp74_ = info;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp75_ = hours;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp76_ = hours;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp77_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) _tmp75_), _tmp76_);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp78_ = _tmp77_;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp79_ = g_strconcat (_tmp74_, _tmp78_, NULL);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (info);
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					info = _tmp79_;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_g_free0 (_tmp78_);
#line 1120 "Utils.c"
				} else {
					gint64 _tmp80_;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					_tmp80_ = seconds;
#line 148 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
					if (_tmp80_ >= ((gint64) 60)) {
#line 1127 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp81_;
						const gchar* _tmp82_;
						gint64 _tmp83_;
						gint64 _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
						gchar* _tmp87_;
#line 149 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp81_ = seconds;
#line 149 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						minutes = _tmp81_ / 60;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp82_ = info;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp83_ = minutes;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp84_ = minutes;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp85_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) _tmp83_), _tmp84_);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp86_ = _tmp85_;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp87_ = g_strconcat (_tmp82_, _tmp86_, NULL);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp87_;
#line 150 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp86_);
#line 1158 "Utils.c"
					} else {
						const gchar* _tmp88_;
						gint64 _tmp89_;
						gint64 _tmp90_;
						gchar* _tmp91_;
						gchar* _tmp92_;
						gchar* _tmp93_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp88_ = info;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp89_ = seconds;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp90_ = seconds;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp91_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp89_), _tmp90_);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp92_ = _tmp91_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_tmp93_ = g_strconcat (_tmp88_, _tmp92_, NULL);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (info);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						info = _tmp93_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
						_g_free0 (_tmp92_);
#line 1184 "Utils.c"
					}
				}
			}
		}
	}
#line 157 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	result = info;
#line 157 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	return result;
#line 1194 "Utils.c"
}


void power_utils_translations (void) {
#line 162 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld day until full", "%lld days until full", (gulong) 0);
#line 163 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld hour until full", "%lld hours until full", (gulong) 0);
#line 164 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld minute until full", "%lld minutes until full", (gulong) 0);
#line 165 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld second until full", "%lld seconds until full", (gulong) 0);
#line 166 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld day until empty", "%lld days until empty", (gulong) 0);
#line 167 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld hour until empty", "%lld hours until empty", (gulong) 0);
#line 168 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld minute until empty", "%lld minutes until empty", (gulong) 0);
#line 169 "/builddir/build/BUILD/wingpanel-indicator-power-2.1.1/src/Utils.vala"
	ngettext ("%lld second until empty", "%lld seconds until empty", (gulong) 0);
#line 1215 "Utils.c"
}



